﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization.Json;
using System.IO;
using System.Runtime.Serialization;

namespace CSharpSync2chSample
{
    [DataContract]
    class Sync2chConf
    {
        private const string CONFNAME = "\\conf.txt";

        public Sync2chConf()
        {
            SyncNumber = "0";
            ClientID = "0";
        }
        /// <summary>
        /// ID
        /// </summary>
        [DataMember]
        public string ID { get; set; }

        /// <summary>
        /// API接続用パスワード
        /// </summary>
        [DataMember]
        public string Pass { get; set; }

        /// <summary>
        /// 同期番号
        /// </summary>
        [DataMember]
        public string SyncNumber { get; set; }

        /// <summary>
        /// 初回同期時に受け取るClientID
        /// </summary>
        [DataMember]
        public string ClientID { get; set; }
        


        
        public void Save()
        {
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(Sync2chConf));

            var dirInfo = new DirectoryInfo(Environment.CurrentDirectory);

            FileInfo fileInfo = new FileInfo(dirInfo.FullName + CONFNAME);
            
            using (Stream stream = (fileInfo != null && fileInfo.Exists) ? fileInfo.Open(FileMode.Truncate, FileAccess.Write) : fileInfo.Create())
            {
                serializer.WriteObject(stream, this);
            }
        }

        public static Sync2chConf OpenSaveData()
        {
            DataContractJsonSerializer serializer = new DataContractJsonSerializer(typeof(Sync2chConf));

            var dirInfo = new DirectoryInfo(Environment.CurrentDirectory);

            FileInfo fileInfo = new FileInfo(dirInfo.FullName + CONFNAME);

            try
            {
                using (Stream stream = (fileInfo != null && fileInfo.Exists) ? fileInfo.OpenRead() : fileInfo.Create())
                {
                    Sync2chConf infoc = (Sync2chConf)serializer.ReadObject(stream);
                    return infoc;
                }

            }
            catch (System.Runtime.Serialization.SerializationException e)
            {
                Console.WriteLine(e.StackTrace);
            }

            return new Sync2chConf();
        }
    }
}
